package modelgen

import java.util.HashMap
import java.util.Map
import org.eclipse.emf.ecore.util.EcoreUtil

@Data
class IdStorage {

	public val static modelId = EcoreUtil.generateUUID

	val stateMachineId = EcoreUtil.generateUUID
	val regionId = EcoreUtil.generateUUID

	val initStateId = EcoreUtil.generateUUID
	val initShapeId = EcoreUtil.generateUUID
	val initTransitionId = EcoreUtil.generateUUID

	val Map<Integer, String> stateIds = new HashMap
	val Map<Integer, String> shapeIds = new HashMap
	val Map<Pair<Integer, Integer>, String> transitionIds = new HashMap

	new() {
		putState(-1, initStateId)
		putShape(-1, initShapeId)
		putTransitionId(-1, 0, initTransitionId)
	}

	def putState(int number, String id) {
		stateIds.put(number, id)
	}

	def getState(int number) {
		stateIds.get(number)
	}

	def putShape(int number, String id) {
		shapeIds.put(number, id)
	}

	def getShape(int number) {
		shapeIds.get(number)
	}

	def putTransitionId(int source, int target, String id) {
		transitionIds.put(source -> target, id)
	}

	def getTransitionId(int source, int target) {
		transitionIds.get(source -> target)
	}
}
