package modelgen;

public class Layout {

	public static final int gap = 40;

	private static final int stateWidth = 40;
	private static final int stateHeight = 40;

	private final int columns;
	private final int regionWidth;
	private final int regionHeight;

	public Layout(int numberOfStates) {
		columns = (int) Math.round(Math.sqrt(numberOfStates));
		regionWidth = gap + (stateWidth + gap) * columns;
		regionHeight = gap * 3 + (stateHeight + gap * 2)
				* (numberOfStates / columns);
	}

	public int getRegionWidth() {
		return regionWidth;
	}

	public int getRegionHeight() {
		return regionHeight;
	}

	public int getStateX(int number) {
		int c = number % columns;
		int q = (number / columns) % 2 < 1 ? c : columns - 1 - c;
		return gap + (stateWidth + gap) * q;
	}

	public int getStateY(int number) {
		return gap * 3 + (stateHeight + gap) * (number / columns);
	}
}
