package modelgen;

import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

import com.google.common.base.Charsets;
import com.google.common.io.Files;

public class Main {

	public static void main(String[] args) {
		String modelName = args[0];
		int numberOfMachines = Integer.parseInt(args[1]);
		int numberOfStates = Integer.parseInt(args[2]);

		IdStorage[] idStorages = new IdStorage[numberOfMachines];
		for (int i = 0; i < numberOfMachines; ++i) {
			idStorages[i] = new IdStorage();
		}

		List<ModelPartGenerator> generators = new ArrayList<>();
		generators.add(new DiGenerator());
		generators.add(new UMLGenerator(idStorages, numberOfStates));
		generators.add(new NotationGenerator(idStorages, modelName));
		generators
				.forEach(generaror -> {
					Path path = Paths.get(modelName + generaror.getExtenstion());
					try {
						Files.write(generaror.generate(), path.toFile(),
								Charsets.UTF_8);
					} catch (Exception e) {
						e.printStackTrace();
						System.exit(1);
					}
				});
		System.out.println("Model generation done.");
	}
}
