package hu.eltesoft.modelexecution.m2m.logic.queryregression;


import hu.eltesoft.modelexecution.uml.incquery.Behavior;
import hu.eltesoft.modelexecution.uml.incquery.Classdef;
import hu.eltesoft.modelexecution.uml.incquery.Event;
import hu.eltesoft.modelexecution.uml.incquery.Region;
import hu.eltesoft.modelexecution.uml.incquery.Signal;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.incquery.runtime.api.GenericPatternGroup;
import org.eclipse.incquery.runtime.api.IQueryGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * @author Abel Hegedus
 *
 */
//@Ignore("Should not run as part of the build, run on demand")
public class UMLQueryPerformanceTest extends QueryPerformanceTest {
	
	
    private static final String INPUT_MODEL_PATH = "/hu.eltesoft.modelexecution.m2m.logic.tests/resources/model15k.uml";


    @Override
    public IQueryGroup getQueryGroup() throws IncQueryException {
        return GenericPatternGroup.of(
                //Insert patterns here
        		Behavior.instance(),
        		Classdef.instance(),
        		Event.instance(),
        		Region.instance(),
        		Signal.instance()
                );
    }

	@Override
	public ResourceSet getResourceSet() throws IncQueryException {
		ResourceSetImpl rs = new ResourceSetImpl();
        URI umlModelUri = URI.createPlatformPluginURI(INPUT_MODEL_PATH, true);
        rs.getResource(umlModelUri, true);
        return rs;
	}

}