package hu.eltesoft.modelexecution.m2m.logic.viatra.tests;

import static org.junit.Assert.assertEquals;
import hu.eltesoft.modelexecution.m2m.logic.viatra.MTMBatchTransformation;

import org.eclipse.emf.ecore.resource.Resource;
import org.junit.Test;

public class SimpleM2MTranslatorTests extends IncQueryBasedTestCase {	

	private MTMBatchTransformation transformation;
	protected Resource resource;

	protected void initTranslator(String inPath, String outPath) {
		resource = createResource(outPath);
		transformation = new MTMBatchTransformation();
		transformation.initialize(resource, configureEngine(inPath));
	}

	@Test
	public void testingFullBuildOnSimpleModel() {
		initTranslator(UML_TEST_SIMPLE_MODEL_PATH, UML_TEST_SIMPLE_OUT_PATH);

		
		transformation.execute();
		
		
		assertEquals(UML_TEST_SIMPLE_MODEL_EXPECTED_FILES.length, resource.getContents().size());
	}
	
	@Test
	public void testingFullBuildOn2015Q1Model() {
		initTranslator(UML_TEST_2015_Q1_MODEL_PATH, UML_TEST_2015_Q1_OUT_PATH);


		transformation.execute();

		assertEquals(UML_TEST_2015_Q1_MODEL_EXPECTED_FILES.length, resource.getContents().size());

	}
	
	@Test
	public void testingFullBuildOnTest10000Model() {
		initTranslator(UML_TEST_LARGE_MODEL_PATH, UML_TEST_LARGE_OUT_PATH);


		transformation.execute();

		assertEquals(UML_TEST_LARGE_MODEL_EXPECTED_FILES.length, resource.getContents().size());

	}

}
